{****************************************************
 *                                                  *
 *          SP-Hilfe v2.0 fr SP6.05.00             *
 *                                                  *
 ****************************************************}
{$A+,L-,R-,S-,I+,F-,O-,N-,E-,L+,V+,B+,M 10000 0 655360}
program sphelp;
uses   dos;
const  ver = '2.0';
       env = 'SPDIR';
       dat : string[255] = 'HILFE.DAT';
var    f   : text;
       a   : text;
       s   : string[80];
       t   : string[255];
       i   : byte;

function exists(n:string):boolean;
const attr = $20;
var   di   : searchrec;
begin
  findfirst(n,attr,di);
  if doserror=0 then exists:=true else exists:=false
end;

function ok(v,w:string):boolean;
var  b : string[8];
begin
  if w[1]='@' then
   if v=copy(w,2,length(v)) then ok:=true else ok:=false
  else ok:=false
end;

begin
  assign(a,'');
  rewrite(a);
  if (paramcount=0) or (paramcount=3) then begin
    writeln(a,'Erweiterte Hilfe v',ver,' fr SP6 (c) DB1HZ 1991');
    writeln(a);
    write(a,'Aufruf mit ');
    if paramcount>2 then writeln(a,'//HILFE <Befehl>') else begin
      writeln(a,'HILFE <Befehl>');
      writeln(a);
      writeln(a,'Dieses Programm gehrt zu SP6 in das SPRUN-Verzeichnis.');
      writeln(a,'Die Hifsdatei heit HILFE.DAT, und gehrt ins SPDIR.');
      writeln(a,'Die einzelnen Hilfstexte beginnen mit einer Kopfzeile der Form');
      writeln(a);
      writeln(a,'@<Befehl>');
      writeln(a);
      writeln(a,'Der Befehl besteht aus bis zu 8 Grobuchstaben. Die nachfolgenden');
      writeln(a,'Zeilen enthalten den Text, der ausgegeben werden soll. Das Programm');
      writeln(a,'gibt aus, bis eine Zeile mit @ beginnt, oder die Datei zu Ende ist.');
      writeln(a,'Die Befehle werden verglichen, indem die aus der Datei ermittelten');
      writeln(a,'Befehle auf die Lnge des zu suchenden Befehls gekrzt und verglichen');
      writeln(a,'werden. Also: fr C mu @C vor @CA stehen - sonst wird CA gefunden...')
    end
  end else begin
    dat:=getenv(env)+'\'+dat;
    if exists(dat) then begin
      writeln(a);
      s:=paramstr(1);
      for i:=1 to length(s) do s[i]:=upcase(s[i]);
      while (length(s)>0) and (s[1]='/') do delete(s,1,1);
      s:=copy(s,1,8);
      assign(f,dat);
      reset(f);
      if ioresult=0 then begin
        t:='';
        while not eof(f) and not ok(s,t) do readln(f,t);
        if not eof(f) then begin
          readln(f,t);
          while (t[1]<>'@') and not eof(f) do begin
            writeln(a,t);
            readln(f,t)
          end;
          if eof(f) then writeln(a,t)
        end else writeln(a,'SP-HILFE> sri, keine erweiterte Hilfe zu ',s,' gefunden');
        close(f)
      end else writeln(a,'SP-HILFE> sri, die Hilfsdatei kann nicht korrekt gelesen werden')
    end else writeln(a,'SP-HILFE> sri, die Hilfsdatei fehlt oder steht nicht im SPDIR')
  end;
  writeln(a);
  close(a);
end.
